kvm-build.sh 2.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172
  1. #!/bin/bash
  2. #
  3. # Build a kvm-ready Linux kernel from the tree in the current directory.
  4. #
  5. # Usage: kvm-build.sh config-template build-dir more-configs
  6. #
  7. # This program is free software; you can redistribute it and/or modify
  8. # it under the terms of the GNU General Public License as published by
  9. # the Free Software Foundation; either version 2 of the License, or
  10. # (at your option) any later version.
  11. #
  12. # This program is distributed in the hope that it will be useful,
  13. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  14. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  15. # GNU General Public License for more details.
  16. #
  17. # You should have received a copy of the GNU General Public License
  18. # along with this program; if not, you can access it online at
  19. # http://www.gnu.org/licenses/gpl-2.0.html.
  20. #
  21. # Copyright (C) IBM Corporation, 2011
  22. #
  23. # Authors: Paul E. McKenney <paulmck@linux.vnet.ibm.com>
  24. config_template=${1}
  25. if test -z "$config_template" -o ! -f "$config_template" -o ! -r "$config_template"
  26. then
  27. echo "kvm-build.sh :$config_template: Not a readable file"
  28. exit 1
  29. fi
  30. builddir=${2}
  31. if test -z "$builddir" -o ! -d "$builddir" -o ! -w "$builddir"
  32. then
  33. echo "kvm-build.sh :$builddir: Not a writable directory, cannot build into it"
  34. exit 1
  35. fi
  36. moreconfigs=${3}
  37. if test -z "$moreconfigs" -o ! -r "$moreconfigs"
  38. then
  39. echo "kvm-build.sh :$moreconfigs: Not a readable file"
  40. exit 1
  41. fi
  42. T=/tmp/test-linux.sh.$$
  43. trap 'rm -rf $T' 0
  44. mkdir $T
  45. grep -v 'CONFIG_[A-Z]*_TORTURE_TEST' < ${config_template} > $T/config
  46. cat << ___EOF___ >> $T/config
  47. CONFIG_INITRAMFS_SOURCE="$TORTURE_INITRD"
  48. CONFIG_VIRTIO_PCI=y
  49. CONFIG_VIRTIO_CONSOLE=y
  50. ___EOF___
  51. cat $moreconfigs >> $T/config
  52. configinit.sh $T/config O=$builddir
  53. retval=$?
  54. if test $retval -gt 1
  55. then
  56. exit 2
  57. fi
  58. ncpus=`cpus2use.sh`
  59. make O=$builddir -j$ncpus $TORTURE_KMAKE_ARG > $builddir/Make.out 2>&1
  60. retval=$?
  61. if test $retval -ne 0 || grep "rcu[^/]*": < $builddir/Make.out | egrep -q "Stop|Error|error:|warning:" || egrep -q "Stop|Error|error:" < $builddir/Make.out
  62. then
  63. echo Kernel build error
  64. egrep "Stop|Error|error:|warning:" < $builddir/Make.out
  65. echo Run aborted.
  66. exit 3
  67. fi